scala.tools.nsc.backend.icode.Members

# IMethod

###
Related Doc: package Members

#### class IMethod extends ICodes.IMember

Represents a method in ICode. Local variables contain both locals and parameters, similar to the way the JVM 'sees' them.

Locals and parameters are added in reverse order, as they are kept in cons-lists. The 'builder' is responsible for reversing them and putting them back, when the generation is finished (GenICode does that).

Source
  Members.scala

Linear Supertypes
ICodes.IMember, math.Ordered[ICodes.IMember], Comparable[ICodes.IMember], AnyRef, Any
Known Subclasses
NoIMethod
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. IMethod
2. IMember
3. Ordered
4. Comparable
5. AnyRef
6. Any

Implicitly

1. by orderingToOrdered
2. by any2stringadd
3. by StringFormat
4. by Ensuring
5. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new IMethod(symbol: Global.Symbol)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ICodes.IMethod to any2stringadd[ICodes.IMethod] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ICodes.IMethod, B)

   Implicit information
     This member is added by an implicit conversion from ICodes.IMethod to ArrowAssoc[ICodes.IMethod] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### def <(that: ICodes.IMember): Boolean

   Definition Classes
     Ordered

6. #### def <=(that: ICodes.IMember): Boolean

   Definition Classes
     Ordered

7. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

8. #### def >(that: ICodes.IMember): Boolean

   Definition Classes
     Ordered

9. #### def >=(that: ICodes.IMember): Boolean

   Definition Classes
     Ordered

10. #### def addHandler(e: ICodes.ExceptionHandler): Unit

11. #### def addLocal(l: ICodes.Local): ICodes.Local

12. #### def addLocals(ls: List[ICodes.Local]): Unit

13. #### def addParam(p: ICodes.Local): Unit

14. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

15. #### def blocks: List[ICodes.BasicBlock]

16. #### var bytecodeHasEHs: Boolean

17. #### var bytecodeHasInvokeDynamic: Boolean

18. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate() @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

19. #### var code: ICodes.Code

20. #### def compare(other: ICodes.IMember): Int

    Definition Classes
      IMember → Ordered

21. #### def compareTo(that: ICodes.IMember): Int

    Definition Classes
      Ordered → Comparable

22. #### def dump(): Unit

23. #### def ensuring(cond: (ICodes.IMethod) ⇒ Boolean, msg: ⇒ Any): ICodes.IMethod

    Implicit information
      This member is added by an implicit conversion from ICodes.IMethod to Ensuring[ICodes.IMethod] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

24. #### def ensuring(cond: (ICodes.IMethod) ⇒ Boolean): ICodes.IMethod

    Implicit information
      This member is added by an implicit conversion from ICodes.IMethod to Ensuring[ICodes.IMethod] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

25. #### def ensuring(cond: Boolean, msg: ⇒ Any): ICodes.IMethod

    Implicit information
      This member is added by an implicit conversion from ICodes.IMethod to Ensuring[ICodes.IMethod] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

26. #### def ensuring(cond: Boolean): ICodes.IMethod

    Implicit information
      This member is added by an implicit conversion from ICodes.IMethod to Ensuring[ICodes.IMethod] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

27. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

28. #### def equals(other: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      IMember → AnyRef → Any

29. #### var exh: List[ICodes.ExceptionHandler]

    The list of exception handlers, ordered from innermost to outermost.

30. #### def foreachBlock[U](f: (ICodes.BasicBlock) ⇒ U): Unit

31. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ICodes.IMethod to StringFormat[ICodes.IMethod] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

32. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

33. #### def hasCode: Boolean

34. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      IMember → AnyRef → Any

35. #### def isAbstractMethod: Boolean

    Is this method deferred ('abstract' in Java sense)?

36. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

37. #### def isStatic: Boolean

38. #### def lastBlock: ICodes.BasicBlock

39. #### def linearizedBlocks(lin: ICodes.Linearizer = self.linearizer): List[ICodes.BasicBlock]

40. #### var locals: List[ICodes.Local]

    local variables and method parameters

41. #### def lookupLocal(sym: Global.Symbol): Option[ICodes.Local]

42. #### def lookupLocal(n: Global.Name): Option[ICodes.Local]

43. #### var native: Boolean

44. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

45. #### def newBlock(): ICodes.BasicBlock

46. #### def normalize(): Unit

    Merge together blocks that have a single successor which has a single predecessor.

    Merge together blocks that have a single successor which has a single predecessor. Exception handlers are taken into account (they might force to break a block of straight line code like that).

    This method should be most effective after heavy inlining.

47. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

48. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

49. #### var params: List[ICodes.Local]

    method parameters

50. #### var recursive: Boolean

51. #### var returnType: ICodes.TypeKind

52. #### def setCode(code: ICodes.Code): ICodes.IMethod

53. #### var sourceFile: SourceFile

54. #### def startBlock: ICodes.BasicBlock

55. #### val symbol: Global.Symbol

    Definition Classes
      IMethod → IMember

56. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

57. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      IMethod → AnyRef → Any

58. #### final def updateRecursive(called: Global.Symbol): Unit

59. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

60. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

61. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

62. #### def →[B](y: B): (ICodes.IMethod, B)

    Implicit information
      This member is added by an implicit conversion from ICodes.IMethod to ArrowAssoc[ICodes.IMethod] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1. #### def <(that: ICodes.IMethod): Boolean

   Implicit information
     This member is added by an implicit conversion from ICodes.IMethod to math.Ordered[ICodes.IMethod] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[ICodes.IMethod] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (iMethod: math.Ordered[ICodes.IMethod]).<(that)

   Definition Classes
     Ordered

2. #### def <=(that: ICodes.IMethod): Boolean

   Implicit information
     This member is added by an implicit conversion from ICodes.IMethod to math.Ordered[ICodes.IMethod] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[ICodes.IMethod] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (iMethod: math.Ordered[ICodes.IMethod]).<=(that)

   Definition Classes
     Ordered

3. #### def >(that: ICodes.IMethod): Boolean

   Implicit information
     This member is added by an implicit conversion from ICodes.IMethod to math.Ordered[ICodes.IMethod] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[ICodes.IMethod] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (iMethod: math.Ordered[ICodes.IMethod]).>(that)

   Definition Classes
     Ordered

4. #### def >=(that: ICodes.IMethod): Boolean

   Implicit information
     This member is added by an implicit conversion from ICodes.IMethod to math.Ordered[ICodes.IMethod] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[ICodes.IMethod] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (iMethod: math.Ordered[ICodes.IMethod]).>=(that)

   Definition Classes
     Ordered

5. #### def compare(that: ICodes.IMethod): Int

   Implicit information
     This member is added by an implicit conversion from ICodes.IMethod to math.Ordered[ICodes.IMethod] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[ICodes.IMethod] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (iMethod: math.Ordered[ICodes.IMethod]).compare(that)

   Definition Classes
     Ordered

6. #### def compareTo(that: ICodes.IMethod): Int

   Implicit information
     This member is added by an implicit conversion from ICodes.IMethod to math.Ordered[ICodes.IMethod] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[ICodes.IMethod] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (iMethod: math.Ordered[ICodes.IMethod]).compareTo(that)

   Definition Classes
     Ordered → Comparable

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from ICodes.IMember

### Inherited from math.Ordered[ICodes.IMember]

### Inherited from Comparable[ICodes.IMember]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion orderingToOrdered from ICodes.IMethod to math.Ordered[ICodes.IMethod]

### Inherited by implicit conversion any2stringadd from ICodes.IMethod to any2stringadd[ICodes.IMethod]

### Inherited by implicit conversion StringFormat from ICodes.IMethod to StringFormat[ICodes.IMethod]

### Inherited by implicit conversion Ensuring from ICodes.IMethod to Ensuring[ICodes.IMethod]

### Inherited by implicit conversion ArrowAssoc from ICodes.IMethod to ArrowAssoc[ICodes.IMethod]

### Ungrouped